'''
gnuplot commands are represented through objects of the GnuPlot class,
they are added to the commandstring with #add, which is executed by GnuPlot.show
'''

class GnuPlot
  
  @@commandstring=''
    
  def initialize(command,options='')
    @command=command
    @options=options
  end
  
  def add 
    c=@command+' '+@options
    @@commandstring=@@commandstring+"; " unless @@commandstring==''
    @@commandstring=@@commandstring+c
  end
  
  def self.show
   `gnuplot -persist -e \"#{@@commandstring}\"`
  end
   
  def self.commandstring
    @@commandstring
  end
   
  def self.commandstring_reset
    @@commandstring=''
  end
   
end




__END__

#Example:
   
The file p.csv has five lines:
    0,0,0
    1,1,1
    2,4,9
    3,9,27
    4,16,64


csv=GnuPlot.new("set datafile separator","','")
terminal=GnuPlot.new("set terminal","'#{GnuPlotDefaults::TERMINAL}'")
linestyle1=GnuPlot.new("set style","line 1 lt 1 lw 2 lc rgb 'green' ps 0")
linestyle2=GnuPlot.new("set style","line 2 lt 1 lw 2 lc rgb 'red' ps 0")
plot=GnuPlot.new("plot"," 'p.csv' using 1:2 with linespoints ls 1 title 'Graph 1', 'p.csv' using 1:3 with linespoints ls 2 notitle ")

csv.add
terminal.add
linestyle1.add
linestyle2.add
plot.add

GnuPlot.show


